#region Using declarations
using System;
                            using System.Collections;
                            using System.Collections.Generic;
                            using System.ComponentModel;
                            using System.ComponentModel.DataAnnotations;
                            using System.Diagnostics.CodeAnalysis;
                            using System.Windows;
                            using System.Reflection;
                            using System.Windows.Media;
                            using System.Xml.Serialization;
                            using NinjaTrader.Cbi;
                            using NinjaTrader.Data;
                            using NinjaTrader.Gui;
                            using NinjaTrader.Gui.Chart;
                            using NinjaTrader.Gui.Tools;
                            using NinjaTrader.NinjaScript.DrawingTools;
                            using NinjaTrader.NinjaScript.Indicators;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.NinjaScript.Indicators
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    public class LargeTrades : Indicator
    {
        #region Variables 
		private int vol = 5;
		private int fix = 1; 
		Brush color =  Brushes.Navy;
		Brush colorText = Brushes.White;
		Brush shadowcolor =Brushes.Transparent;
		int opacity = 50;
		private bool useAlerts = false;
		private bool useRectangle = true;
		private double barWidthP = 0;
		//private bool ShowTime = false;
		private string stringtoAlert = "Alert4.wav";
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
		/// 
        private void Initialize()
        {                
            Calculate	= Calculate.OnBarClose;
			IsOverlay				= true;	
			
				
        }

        protected override void OnStateChange()
        {
            switch (State)
            {
                case State.SetDefaults:
                    Name = "LargeTrades";
                    Description = "Enter the description of your new custom indicator here";
                    Initialize();
                    break;
             }
		if (State == State.Configure)
    	{
			AddDataSeries(BarsPeriodType.Second,1);
		}
        }
        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
       protected override void OnBarUpdate()
        {
					
	        if (CurrentBar < 2) return;
			if (BarsInProgress == 1)
				
			{			
				TimeSpan ts1 = Time[0] - new DateTime(1970,1,1,0,0,0);
			    TimeSpan ts2 = Time[1] - new DateTime(1970,1,1,0,0,0);

			   // int timeGap=(int)Time[0].Second-(int)Time[1].Second;
				int timeGap=(int)ts1.TotalSeconds-(int)ts2.TotalSeconds;

			if (Volume[0]>=vol && Math.Abs(timeGap)<=fix)
			    {	
				if(useRectangle)	
		
			    Draw.Rectangle(this,"Rectangle"+CurrentBar, true, 0, High[0]+2*TickSize,-2 , Low[0]-2*TickSize, shadowcolor, color, opacity);
			    
				if(false)	
				{
				//DrawText("TFx"+CurrentBar, true, Convert.ToString(Volume[0]), 0, Median[0], 0,Color.White, 
					Draw.Text(this,"TFx"+CurrentBar, true, Convert.ToString(Time[0]),1, Median[0], 0,colorText, 
				new SimpleFont("Small Fonts", 9)/*new Font("Small Fonts", 7, FontStyle.Regular)*/, TextAlignment.Right,	Brushes.Transparent,Brushes.Transparent, 0);
				}
				else
				{
				//Draw.Text(this,"TFx"+CurrentBar, true, Convert.ToString(Volume[0]), 1, Median[0], 0,colorText, 
						//new SimpleFont("Small Fonts", 9)/*new Font("Small Fonts", 7, FontStyle.Regular)*/, TextAlignment.Right,Brushes.Transparent, Brushes.Transparent, 0);
				}
				}
        
		}
			}
		#region Properties	
		[NinjaScriptProperty]		[Display(Name = "1.Мин. объём сделок", Description = "Минимальный объём суммы сделок для отображения метки", GroupName = "Parameters", Order = 1)]		public int Объём
        {
            get { return vol; }
            set { vol = Math.Max(1, value); }
        }
        [NinjaScriptProperty]        [Display(Name = "2.Время, сек", Description = "Время в сек, за которое суммируются сделки", GroupName = "Parameters", Order = 1)]        public int Время
        {
            get { return fix; }
            set { fix = Math.Max(1, value); }
        }
		
		[NinjaScriptProperty]		
		[Display(Name = "3.Цвет Метки", Description = "Цвет метки сделки", GroupName = "Parameters", Order = 1)]		
		public Brush Цвет
		{
			get{return color;}
			set{color = value;}
		}

        [NinjaScriptProperty]        [Display(Name = "1.Отображение сделки", Description = "Отображение сделки", GroupName = "Parameters-Other", Order = 1)]        public bool Эллипс
        {
            get { return useRectangle; }
            set {useRectangle = value; }
        }	
       
        [NinjaScriptProperty]        [Display(Name = "3.Звуковой сигнал", Description = "Звуковой сигнал", GroupName = "Parameters-Other", Order = 1)]        public bool Звуковой_сигнал
        {
            get { return useAlerts; }
            set {useAlerts = value; }
        }			
        [NinjaScriptProperty]        [Display(Name = "4.Имя звукового файла", Description = "Имя звукового файла", GroupName = "Parameters-Other", Order = 1)]        public string StringtoAlert
        {
            get { return stringtoAlert; }
            set {stringtoAlert = value; }
        }		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private LargeTrades[] cacheLargeTrades;
		public LargeTrades LargeTrades(string stringtoAlert)
		{
			return LargeTrades(Input, stringtoAlert);
		}

		public LargeTrades LargeTrades(ISeries<double> input, string stringtoAlert)
		{
			if (cacheLargeTrades != null)
				for (int idx = 0; idx < cacheLargeTrades.Length; idx++)
					if (cacheLargeTrades[idx] != null && cacheLargeTrades[idx].StringtoAlert == stringtoAlert && cacheLargeTrades[idx].EqualsInput(input))
						return cacheLargeTrades[idx];
			return CacheIndicator<LargeTrades>(new LargeTrades(){ StringtoAlert = stringtoAlert }, input, ref cacheLargeTrades);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.LargeTrades LargeTrades(string stringtoAlert)
		{
			return indicator.LargeTrades(Input, stringtoAlert);
		}

		public Indicators.LargeTrades LargeTrades(ISeries<double> input , string stringtoAlert)
		{
			return indicator.LargeTrades(input, stringtoAlert);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.LargeTrades LargeTrades(string stringtoAlert)
		{
			return indicator.LargeTrades(Input, stringtoAlert);
		}

		public Indicators.LargeTrades LargeTrades(ISeries<double> input , string stringtoAlert)
		{
			return indicator.LargeTrades(input, stringtoAlert);
		}
	}
}

#endregion
